package jp.co.student.springbootstudy.domain.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Date;
import java.util.Iterator;

public class StudentExample {
    /**
	 * This field was generated by MyBatis Generator. This field corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	protected String orderByClause;
	/**
	 * This field was generated by MyBatis Generator. This field corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	protected boolean distinct;
	/**
	 * This field was generated by MyBatis Generator. This field corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	protected List<Criteria> oredCriteria;

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public StudentExample() {
		oredCriteria = new ArrayList<>();
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public void setOrderByClause(String orderByClause) {
		this.orderByClause = orderByClause;
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public String getOrderByClause() {
		return orderByClause;
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public void setDistinct(boolean distinct) {
		this.distinct = distinct;
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public boolean isDistinct() {
		return distinct;
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public List<Criteria> getOredCriteria() {
		return oredCriteria;
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public void or(Criteria criteria) {
		oredCriteria.add(criteria);
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public Criteria or() {
		Criteria criteria = createCriteriaInternal();
		oredCriteria.add(criteria);
		return criteria;
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public Criteria createCriteria() {
		Criteria criteria = createCriteriaInternal();
		if (oredCriteria.size() == 0) {
			oredCriteria.add(criteria);
		}
		return criteria;
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	protected Criteria createCriteriaInternal() {
		Criteria criteria = new Criteria();
		return criteria;
	}

	/**
	 * This method was generated by MyBatis Generator. This method corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public void clear() {
		oredCriteria.clear();
		orderByClause = null;
		distinct = false;
	}

	/**
	 * This class was generated by MyBatis Generator. This class corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	protected abstract static class GeneratedCriteria {
		protected List<Criterion> criteria;

		protected GeneratedCriteria() {
			super();
			criteria = new ArrayList<>();
		}

		public boolean isValid() {
			return criteria.size() > 0;
		}

		public List<Criterion> getAllCriteria() {
			return criteria;
		}

		public List<Criterion> getCriteria() {
			return criteria;
		}

		protected void addCriterion(String condition) {
			if (condition == null) {
				throw new RuntimeException("Value for condition cannot be null");
			}
			criteria.add(new Criterion(condition));
		}

		protected void addCriterion(String condition, Object value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value));
		}

		protected void addCriterion(String condition, Object value1, Object value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value1, value2));
		}

		protected void addCriterionForJDBCDate(String condition, Date value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			addCriterion(condition, new java.sql.Date(value.getTime()), property);
		}

		protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
			if (values == null || values.size() == 0) {
				throw new RuntimeException("Value list for " + property + " cannot be null or empty");
			}
			List<java.sql.Date> dateList = new ArrayList<>();
			Iterator<Date> iter = values.iterator();
			while (iter.hasNext()) {
				dateList.add(new java.sql.Date(iter.next().getTime()));
			}
			addCriterion(condition, dateList, property);
		}

		protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
		}

		public Criteria andStudentIdIsNull() {
			addCriterion("student_id is null");
			return (Criteria) this;
		}

		public Criteria andStudentIdIsNotNull() {
			addCriterion("student_id is not null");
			return (Criteria) this;
		}

		public Criteria andStudentIdEqualTo(String value) {
			addCriterion("student_id =", value, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdNotEqualTo(String value) {
			addCriterion("student_id <>", value, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdGreaterThan(String value) {
			addCriterion("student_id >", value, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdGreaterThanOrEqualTo(String value) {
			addCriterion("student_id >=", value, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdLessThan(String value) {
			addCriterion("student_id <", value, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdLessThanOrEqualTo(String value) {
			addCriterion("student_id <=", value, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdLike(String value) {
			addCriterion("student_id like", value, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdNotLike(String value) {
			addCriterion("student_id not like", value, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdIn(List<String> values) {
			addCriterion("student_id in", values, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdNotIn(List<String> values) {
			addCriterion("student_id not in", values, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdBetween(String value1, String value2) {
			addCriterion("student_id between", value1, value2, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentIdNotBetween(String value1, String value2) {
			addCriterion("student_id not between", value1, value2, "studentId");
			return (Criteria) this;
		}

		public Criteria andStudentNameIsNull() {
			addCriterion("student_name is null");
			return (Criteria) this;
		}

		public Criteria andStudentNameIsNotNull() {
			addCriterion("student_name is not null");
			return (Criteria) this;
		}

		public Criteria andStudentNameEqualTo(String value) {
			addCriterion("student_name =", value, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameNotEqualTo(String value) {
			addCriterion("student_name <>", value, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameGreaterThan(String value) {
			addCriterion("student_name >", value, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameGreaterThanOrEqualTo(String value) {
			addCriterion("student_name >=", value, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameLessThan(String value) {
			addCriterion("student_name <", value, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameLessThanOrEqualTo(String value) {
			addCriterion("student_name <=", value, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameLike(String value) {
			addCriterion("student_name like", value, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameNotLike(String value) {
			addCriterion("student_name not like", value, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameIn(List<String> values) {
			addCriterion("student_name in", values, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameNotIn(List<String> values) {
			addCriterion("student_name not in", values, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameBetween(String value1, String value2) {
			addCriterion("student_name between", value1, value2, "studentName");
			return (Criteria) this;
		}

		public Criteria andStudentNameNotBetween(String value1, String value2) {
			addCriterion("student_name not between", value1, value2, "studentName");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthIsNull() {
			addCriterion("date_of_birth is null");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthIsNotNull() {
			addCriterion("date_of_birth is not null");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthEqualTo(Date value) {
			addCriterionForJDBCDate("date_of_birth =", value, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthNotEqualTo(Date value) {
			addCriterionForJDBCDate("date_of_birth <>", value, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthGreaterThan(Date value) {
			addCriterionForJDBCDate("date_of_birth >", value, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthGreaterThanOrEqualTo(Date value) {
			addCriterionForJDBCDate("date_of_birth >=", value, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthLessThan(Date value) {
			addCriterionForJDBCDate("date_of_birth <", value, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthLessThanOrEqualTo(Date value) {
			addCriterionForJDBCDate("date_of_birth <=", value, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthIn(List<Date> values) {
			addCriterionForJDBCDate("date_of_birth in", values, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthNotIn(List<Date> values) {
			addCriterionForJDBCDate("date_of_birth not in", values, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthBetween(Date value1, Date value2) {
			addCriterionForJDBCDate("date_of_birth between", value1, value2, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andDateOfBirthNotBetween(Date value1, Date value2) {
			addCriterionForJDBCDate("date_of_birth not between", value1, value2, "dateOfBirth");
			return (Criteria) this;
		}

		public Criteria andGenderIsNull() {
			addCriterion("gender is null");
			return (Criteria) this;
		}

		public Criteria andGenderIsNotNull() {
			addCriterion("gender is not null");
			return (Criteria) this;
		}

		public Criteria andGenderEqualTo(String value) {
			addCriterion("gender =", value, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderNotEqualTo(String value) {
			addCriterion("gender <>", value, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderGreaterThan(String value) {
			addCriterion("gender >", value, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderGreaterThanOrEqualTo(String value) {
			addCriterion("gender >=", value, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderLessThan(String value) {
			addCriterion("gender <", value, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderLessThanOrEqualTo(String value) {
			addCriterion("gender <=", value, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderLike(String value) {
			addCriterion("gender like", value, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderNotLike(String value) {
			addCriterion("gender not like", value, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderIn(List<String> values) {
			addCriterion("gender in", values, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderNotIn(List<String> values) {
			addCriterion("gender not in", values, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderBetween(String value1, String value2) {
			addCriterion("gender between", value1, value2, "gender");
			return (Criteria) this;
		}

		public Criteria andGenderNotBetween(String value1, String value2) {
			addCriterion("gender not between", value1, value2, "gender");
			return (Criteria) this;
		}
	}

	/**
	 * This class was generated by MyBatis Generator. This class corresponds to the database table public.student
	 * @mbg.generated  Wed May 01 11:29:45 JST 2024
	 */
	public static class Criterion {
		private String condition;
		private Object value;
		private Object secondValue;
		private boolean noValue;
		private boolean singleValue;
		private boolean betweenValue;
		private boolean listValue;
		private String typeHandler;

		public String getCondition() {
			return condition;
		}

		public Object getValue() {
			return value;
		}

		public Object getSecondValue() {
			return secondValue;
		}

		public boolean isNoValue() {
			return noValue;
		}

		public boolean isSingleValue() {
			return singleValue;
		}

		public boolean isBetweenValue() {
			return betweenValue;
		}

		public boolean isListValue() {
			return listValue;
		}

		public String getTypeHandler() {
			return typeHandler;
		}

		protected Criterion(String condition) {
			super();
			this.condition = condition;
			this.typeHandler = null;
			this.noValue = true;
		}

		protected Criterion(String condition, Object value, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.typeHandler = typeHandler;
			if (value instanceof List<?>) {
				this.listValue = true;
			} else {
				this.singleValue = true;
			}
		}

		protected Criterion(String condition, Object value) {
			this(condition, value, null);
		}

		protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.secondValue = secondValue;
			this.typeHandler = typeHandler;
			this.betweenValue = true;
		}

		protected Criterion(String condition, Object value, Object secondValue) {
			this(condition, value, secondValue, null);
		}
	}

	/**
     * This class was generated by MyBatis Generator.
     * This class corresponds to the database table public.student
     *
     * @mbg.generated do_not_delete_during_merge Wed Apr 10 11:30:19 JST 2024
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }
}